from h5py import File, Group
import numpy as np
from pathlib import Path

from h5schemas.header.overwrite_header import overwrite_header_at_index

def overwrite_image_at_index(h5_file: File | Group,
    image: Path | np.ndarray,
    index: int, 
    uuid: str | None = None,
    timestamp: int | None = None,
):
    if isinstance(image, Path):
        dst = h5_file["image_path"]
        dst[index] = str(image)
    else:
        dst = h5_file["image_array"]
        dst[index] = image

    overwrite_header_at_index(h5_file["header"], index, uuid, timestamp)