from h5py import File, Group
from thd_json import joint
from h5schemas.scan_schema import open_schema
from h5schemas.initialize_dataset import initialize_dataset


def init_joint(h5_file: File | Group):
    schema_groups = get_source_schemas()
    initialize_dataset(h5_file, schema_groups)


def get_source_schemas():
    return open_schema(joint, "joint.json")


def add_joint_sample(h5_file: File | Group, joint_value_rad):
    dst = h5_file["q"]
    dst.resize((dst.shape[0] + 1,))
    dst[-1,] = joint_value_rad


if __name__ == "__main__":
    test_file = File("./examples/joint.h5", "w")
    init_joint(test_file)

    add_joint_sample(test_file, 1.0)
    add_joint_sample(test_file, 2.0)
    add_joint_sample(test_file, 3.0)
